#!/bin/sh
eval `dbus export kuainiao`
source /koolshare/scripts/base.sh

#双WAN判断
wans_mode=$(nvram get wans_mode)
if [ "$kuainiao_config_wan" == "1" ] && [[ "$wans_mode" == "lb" || "$wans_mode" == "fo" ]]; then
    wan_selected=$(nvram get wan0_ipaddr)
    if [ "$wan_selected" != "0.0.0.0" ]; then
        bind_address=$wan_selected
    else
        bind_address=""
    fi
elif [ "$kuainiao_config_wan" == "2" ] && [[ "$wans_mode" == "lb" || "$wans_mode" == "fo" ]]; then
    wan_selected=$(nvram get wan1_ipaddr)
    if [ "$wan_selected" != "0.0.0.0" ]; then
        bind_address=$wan_selected
    else
        bind_address=""
    fi
else
    bind_address=""
fi

#定义请求函数
if [ -n "$bind_address" ]; then
    HTTP_REQ="wget --bind-address=$bind_address -q --no-check-certificate -O - "
    POST_ARG="--post-data="
else
    HTTP_REQ="wget -q --no-check-certificate -O - "
    POST_ARG="--post-data="
fi

#获取用户真实MAC地址
if [ -n "$bind_address" ] && [ "$kuainiao_config_wan" == "1" ]; then
    nic=wan0_hwaddr
elif [ -n "$bind_address" ] && [ "$kuainiao_config_wan" == "2" ]; then
    nic=wan1_hwaddr
else
    nic=wan_hwaddr
fi
peerid=$(nvram get $nic|awk 'gsub(/:/, "") {printf("%s", toupper($1))}')004V
dbus set kuainiao_config_peerid=$peerid


#从dbus中获取uid，pwd等
uid=$kuainiao_config_uid
uid_orig=$uid
uname=`dbus get kuainiao_config_uname`
pwd=`dbus get kuainiao_config_pwd`
peerid=`dbus get kuainiao_config_peerid`
api_url=`dbus get kuainiao_api_dn`
api_up_url=`dbus get kuainiao_api_up`
devicesign=`dbus get kuainiao_device_sign`
dial_account=`dbus get kuainiao_dial_account`
app_version=`dbus get kuainiao_app_version`
can_upgrade_dn=`dbus get kuainiao_can_upgrade_dn`
can_upgrade_up=`dbus get kuainiao_can_upgrade_up`
session=`dbus get kuainiao_config_session`

get_ip_info() {
    portal=`$HTTP_REQ http://api.$1portal.swjsq.vip.xunlei.com:$2/v2/queryportal`
    portal_ip=`echo $portal|grep -oE '([0-9]{1,3}[\.]){3}[0-9]{1,3}'`
    portal_port_temp=`echo $portal|grep -oE "port...[0-9]{1,5}"`
    portal_port=`echo $portal_port_temp|grep -oE '[0-9]{1,5}'`

}

#获取加速API
get_kuainiao_api() {
    get_ip_info "" "81"
    portal_dn_ip=$portal_ip
    if [ -z "$portal_dn_ip" ]; then
        dbus set kuainiao_run_warnning_dn="迅雷快鸟服务下行API获取失败，请检查网络环境，或稍后再试!"
    else
        api_url="http://$portal_dn_ip:$portal_port/v2"
        dbus set kuainiao_api_dn=$api_url
        if [[ "$can_upgrade_dn" != "518" && "$can_upgrade_dn" != "-1" ]]; then
            dbus set kuainiao_run_warnning_dn=""
        fi
    fi

    get_ip_info "up" "80"
    portal_up_ip=$portal_ip
    if [ -z "$portal_up_ip" ]; then
        dbus set kuainiao_run_warnning_up="迅雷快鸟服务上行API获取失败，请检查网络环境，或稍后再试!"
    else
        api_up_url="http://$portal_up_ip:$portal_port/v2"
        dbus set kuainiao_api_up=$api_up_url
        if [[ "$can_upgrade_up" != "518" && "$can_upgrade_up" != "-1" ]]; then
            dbus set kuainiao_run_warnning_up=""
        fi
    fi

    if [ -z "$portal_dn_ip" ] && [ -z "$portal_up_ip" ]; then
        dbus set kuainiao_run_warnning="迅雷快鸟服务[下行,上行]API获取失败，请检查网络环境，或稍后再试!"
    fi
}

#初始化计数器
if [ -z "$kuainiao_run_i" ]; then
    dbus ram kuainiao_run_i=6
    kuainiao_run_i=6
fi

#初始化运行状态(kuainiao_run_status 0表示运行异常，1表示运行正常)
if [ -z "$kuainiao_run_status" ]; then
    dbus ram kuainiao_run_status=0
    kuainiao_run_status=0
fi

#判断是否可以加速
if [ "$kuainiao_can_upgrade_dn" != "1" ] && [ "$kuainiao_can_upgrade_up" != "1" ]; then
    dbus ram kuainiao_run_i=6
    dbus ram kuainiao_run_status=0
    dbus ram kuainiao_run_warnning="您的宽带不能使用讯鸟快鸟加速！"$(date "+%Y-%m-%d %H:%M:%S")
    exit 21
fi

#初始化日期
if [ -z $kuainiao_run_orig_day ]; then
    day_of_month_orig=`date +%d`
    orig_day_of_month=`echo $day_of_month_orig|grep -oE "[1-9]{1,2}"`
    dbus ram kuainiao_run_orig_day=$orig_day_of_month
    kuainiao_run_orig_day=$orig_day_of_month
fi

#开始执行逻辑
##判断是否跨天
day_of_month_orig=`date +%d`
day_of_month=`echo $day_of_month_orig|grep -oE "[1-9]{1,2}"`
if [[ -z $kuainiao_run_orig_day || $day_of_month -ne $kuainiao_run_orig_day ]]; then
    dbus ram kuainiao_run_orig_day=$day_of_month
    kuainiao_run_orig_day=$day_of_month
    if [ "$can_upgrade_dn" == "1" ]; then
        _ts=`date +%s`000
        $HTTP_REQ "$api_url/recover?peerid=$peerid&client_type=android-swjsq-$app_version&client_version=androidswjsq-$app_version&os=android-8.1.0.27Google&time_and=$_ts&userid=$uid&user_type=1&dial_account=$dial_account"
    fi
    if [ "$can_upgrade_up" == "1" ]; then
        _ts=`date +%s`000
        $HTTP_REQ "$api_up_url/recover?peerid=$peerid&client_type=android-uplink-$app_version&client_version=androiduplink-$app_version&os=android-8.1.0.27Google&time_and=$_ts&userid=$uid&user_type=1&dial_account=$dial_account"
    fi
    dbus ram kuainiao_run_i=6
    kuainiao_run_i=6

    sleep 5
fi

#判断是否需要重新登陆
if test $kuainiao_run_i -ge 6; then
    dbus ram kuainiao_run_i=0
    kuainiao_run_i=0
    if [ "$can_upgrade_dn" == "1" ]; then 
        ret=`$HTTP_REQ "$api_url/upgrade?peerid=$peerid&client_type=android-swjsq-$app_version&client_version=androidswjsq-$app_version&os=android-8.1.0.27Google&time_and=$_ts&userid=$uid&sessionid=$session&user_type=1&dial_account=$dial_account"`
    elif [ "$can_upgrade_up" == "1" ]; then 
        ret=$HTTP_REQ "$api_up_url/upgrade?peerid=$peerid&client_type=android-uplink-$app_version&client_version=androiduplink-$app_version&os=android-8.1.0.27Google&time_and=$_ts&userid=$uid&sessionid=$session&user_type=1&dial_account=$dial_account"
    fi
    errcode=`echo $ret|awk -F '"errno":' '{print $2}'|awk -F ',' '{print $1}'`

    if [ -z "$errcode" ] || [[ "$errcode" != "0" && "$errcode" != "812" ]];then
        ret=`$HTTP_REQ https://mobile-login.xunlei.com:443/login $POST_ARG"{\"protocolVersion\": \"203\", \"sequenceNo\": \"1000001\", \"platformVersion\": \"10\", \"isCompressed\": \"0\", \"appid\": \"68\", \"clientVersion\": \"2.5.2\", \"peerID\": \""$peerid"\", \"appName\": \"ANDROID-com.xunlei.vip.swjsq\", \"sdkVersion\": \"178225\", \"devicesign\": \""$devicesign"\", \"netWorkType\": \"WIFI\", \"providerName\": \"NONE\", \"deviceModel\": \"Google\", \"deviceName\": \"Google\", \"OSVersion\": \"8.1.0\", \"userName\": \""$uname"\", \"passWord\": \""$pwd"\", \"verifyKey\": \"\", \"verifyCode\": \"\", \"isMd5Pwd\": \"0\"}" --header "User-Agent: android-async-http/xl-acc-sdk/version-2.7.2.178225"` 

        session=`echo $ret|awk -F '"sessionID":' '{print $2}'|awk -F ',' '{print $1}'|grep -oE "[A-F,0-9]{32}"`
        uid=`echo $ret|awk -F '"userID":' '{print $2}' | awk -F '"' '{print $2}'`

        #判断登陆是否成功
        if [ -z "$session" ]; then
            #登陆失败重置计数器到6
            dbus ram kuainiao_run_i=6
            errordesc=`echo $ret|awk -F '"errorDesc":' '{print $2}'|awk -F '"' '{print $2}'|awk -F '[' '{print $1}'`
            
            if [ -z "$errordesc" ]; then
                dbus ram kuainiao_run_warnning="迅雷账号登陆失败！请检查迅雷账号配置！"
            else
                dbus ram kuainiao_run_warnning=$errordesc
            fi
            dbus ram kuainiao_run_status=0
            exit 20
        else
            #登陆成功设置登陆日期和session
            day_of_month_orig=`date +%d`
            orig_day_of_month=`echo $day_of_month_orig|grep -oE "[1-9]{1,2}"`
            dbus ram kuainiao_run_orig_day=$orig_day_of_month
            dbus ram kuainiao_config_session=$session
            kuainiao_run_orig_day=$orig_day_of_month
        fi
        #判断返回的uid
        if [ -z "$uid" ]; then
            uid=$uid_orig
        fi
        #登录完成重置下加速api
        get_kuainiao_api
        #开始加速
        if [ "$can_upgrade_dn" == "1" ]; then
            _ts=`date +%s`000
            $HTTP_REQ "$api_url/upgrade?peerid=$peerid&client_type=android-swjsq-$app_version&client_version=androidswjsq-$app_version&os=android-8.1.0.27Google&time_and=$_ts&userid=$uid&sessionid=$session&user_type=1&dial_account=$dial_account"
        fi
        if [ "$can_upgrade_up" == "1" ]; then
            _ts=`date +%s`000
            $HTTP_REQ "$api_up_url/upgrade?peerid=$peerid&client_type=android-uplink-$app_version&client_version=androiduplink-$app_version&os=android-8.1.0.27Google&time_and=$_ts&userid=$uid&sessionid=$session&user_type=1&dial_account=$dial_account"
        fi
    fi
fi

sleep 1

#保持心跳
dn_failed=0
if [ "$can_upgrade_dn" == "1" ]; then
    _ts=`date +%s`000
    ret=`$HTTP_REQ "$api_url/keepalive?peerid=$peerid&client_type=android-swjsq-$app_version&client_version=androidswjsq-$app_version&os=android-8.1.0.27Google&time_and=$_ts&userid=$uid&sessionid=$session&user_type=1&dial_account=$dial_account"`

    errcode=`echo $ret|awk -F '"errno":' '{print $2}'|awk -F ',' '{print $1}'`
    dbus set kuainiao_can_keepalive_dn_errcode=$errcode
    if [ -z "$errcode" ] || [ "$errcode" == "513" ] || [ "$errcode" == "500" ]; then
        dn_failed=1
        dbus ram kuainiao_run_i=6
        dbus ram kuainiao_run_warnning_dn="迅雷快鸟下行心跳保持失败！"$(date "+%Y-%m-%d %H:%M:%S")
        dbus ram kuainiao_run_status=0
    else
        dbus ram kuainiao_run_warnning_dn=""
    fi
fi

up_failed=0
if [ "$can_upgrade_up" == "1" ]; then
    _ts=`date +%s`000
    ret=`$HTTP_REQ "$api_up_url/keepalive?peerid=$peerid&client_type=android-uplink-$app_version&client_version=androiduplink-$app_version&os=android-8.1.0.27Google&time_and=$_ts&userid=$uid&sessionid=$session&user_type=1&dial_account=$dial_account"`

    errcode=`echo $ret|awk -F '"errno":' '{print $2}'|awk -F ',' '{print $1}'`
    dbus set kuainiao_can_keepalive_up_errcode=$errcode
    if [ -z "$errcode" ] || [ "$errcode" == "513" ] || [ "$errcode" == "500" ]; then
        up_failed=1
        dbus ram kuainiao_run_i=6
        dbus ram kuainiao_run_warnning_up="迅雷快鸟上行行心跳保持失败！"$(date "+%Y-%m-%d %H:%M:%S")
        dbus ram kuainiao_run_status=0
    else
        dbus ram kuainiao_run_warnning_up=""
    fi
fi

restart_kuainiao(){
    kuainiaocru=$(cru l | grep "kuainiao")
    if [ ! -z "$kuainiaocru" ]; then
        cru d kuainiao
    fi
    sleep 180
    chmod +x /koolshare/kuainiao/kuainiao.sh
    cru a kuainiao "*/10 * * * * /koolshare/kuainiao/kuainiao.sh"
    sh /koolshare/kuainiao/kuainiao.sh
}

if [[ "$dn_failed" == "1" && "$up_failed" == 1 ]]; then
    dbus ram kuainiao_run_warnning="迅雷快鸟心跳保持失败！"$(date "+%Y-%m-%d %H:%M:%S")
    restart_kuainiao
    exit 22
else
    if [[ "$dn_failed" == "1" || "$up_failed" == 1 ]]; then
        dbus ram kuainiao_run_warnning="迅雷快鸟上行/下行心跳保持失败，3 分钟后将重新连接！"$(date "+%Y-%m-%d %H:%M:%S")
        restart_kuainiao
        exit 22
    fi
    dbus ram kuainiao_run_i=$(expr $kuainiao_run_i + 1)
    dbus ram kuainiao_run_warnning="迅雷快鸟运行正常！"$(date "+%Y-%m-%d %H:%M:%S")
    dbus ram kuainiao_run_status=1
fi
