#!/bin/sh
eval `dbus export kuainiao`
source /koolshare/scripts/base.sh
version="0.3.6"
app_version="2.5.2"
plugin_version="2018.03.25"
kuainiaocru=$(cru l | grep "kuainiao")

dbus set kuainiao_version=$version
dbus set kuainiao_app_version=$app_version
dbus set kuainiao_plugin_version=$plugin_version

#双WAN判断
wans_mode=$(nvram get wans_mode)
if [ "$kuainiao_config_wan" == "1" ] && [[ "$wans_mode" == "lb" || "$wans_mode" == "fo" ]]; then
    wan_selected=$(nvram get wan0_ipaddr)
    if [ "$wan_selected" != "0.0.0.0" ]; then
        bind_address=$wan_selected
    else
        bind_address=""
    fi
elif [ "$kuainiao_config_wan" == "2" ] && [[ "$wans_mode" == "lb" || "$wans_mode" == "fo" ]]; then
    wan_selected=$(nvram get wan1_ipaddr)
    if [ "$wan_selected" != "0.0.0.0" ]; then
        bind_address=$wan_selected
    else
        bind_address=""
    fi
else
    bind_address=""
fi

#定义请求函数
if [ -n "$bind_address" ]; then
    HTTP_REQ="wget --bind-address=$bind_address -q --no-check-certificate -O - "
    POST_ARG="--post-data="
else
    HTTP_REQ="wget -q --no-check-certificate -O - "
    POST_ARG="--post-data="
fi

#获取用户真实MAC地址
if [ -n "$bind_address" ] && [ "$kuainiao_config_wan" == "1" ]; then
    nic=wan0_hwaddr
elif [ -n "$bind_address" ] && [ "$kuainiao_config_wan" == "2" ]; then
    nic=wan1_hwaddr
else
    nic=wan_hwaddr
fi
peerid=$(nvram get $nic|awk 'gsub(/:/, "") {printf("%s", toupper($1))}')004V
dbus set kuainiao_config_peerid=$peerid

uname=`dbus get kuainiao_config_uname`
pwd=`dbus get kuainiao_config_pwd`
devicesign=`dbus get kuainiao_device_sign`
vkey=`dbus get kuainiao_config_verify_key`
vcode=`dbus get kuainiao_config_verify_code`

#获取迅雷用户uid
get_xunlei_uid(){
    ret=`$HTTP_REQ https://mobile-login.xunlei.com:443/login $POST_ARG"{\"protocolVersion\": \"203\", \"sequenceNo\": \"1000001\", \"platformVersion\": \"10\", \"isCompressed\": \"0\", \"appid\": \"68\", \"clientVersion\": \"2.5.2\", \"peerID\": \""$peerid"\", \"appName\": \"ANDROID-com.xunlei.vip.swjsq\", \"sdkVersion\": \"178225\", \"devicesign\": \""$devicesign"\", \"netWorkType\": \"WIFI\", \"providerName\": \"NONE\", \"deviceModel\": \"Google\", \"deviceName\": \"Google\", \"OSVersion\": \"8.1.0\", \"userName\": \""$uname"\", \"passWord\": \""$pwd"\", \"verifyKey\": \""$vkey"\", \"verifyCode\": \""$vcode"\", \"isMd5Pwd\": \"0\"}" --header "User-Agent: android-async-http/xl-acc-sdk/version-2.7.2.178225"`

    #判断是否登陆成功
    session=`echo $ret|awk -F '"sessionID":' '{print $2}'|awk -F ',' '{print $1}'|grep -oE "[A-F,0-9]{32}"`

    if [ -z "$session" ]; then
        errordesc=`echo $ret|awk -F '"errorDesc":' '{print $2}'|awk -F '"' '{print $2}'|awk -F '[' '{print $1}'`
        errorcode=`echo $ret|awk -F '"errorCode":' '{print $2}'|awk -F '"' '{print $2}'`

        if [ "$errorcode" == "6" ]; then
            errordescurl=`echo $ret|awk -F '"errorDescUrl":' '{print $2}'|awk -F '"' '{print $2}'`
            dbus set kuainiao_run_warnning=$errordesc
            dbus set kuainiao_config_verify_url=${errordescurl//\\/}

        elif [ -z "$errordesc"  ]; then
            dbus set kuainiao_run_warnning="迅雷账号登陆失败，请检查输入的用户名密码!"
            dbus set kuainiao_config_verify_url=""
            dbus set kuainiao_config_verify_key=""
            dbus set kuainiao_config_verify_code=""
        else
            dbus set kuainiao_run_warnning=$errordesc
            dbus set kuainiao_config_verify_url=""
            dbus set kuainiao_config_verify_key=""
            dbus set kuainiao_config_verify_code=""
        fi
    else
        uid=`echo $ret|awk -F '"userID":' '{print $2}' | awk -F '"' '{print $2}'`
        dbus set kuainiao_config_uid=$uid
        dbus set kuainiao_config_session=$session
        dbus set kuainiao_run_warnning=""
        dbus set kuainiao_config_verify_url=""
        dbus set kuainiao_config_verify_key=""
        dbus set kuainiao_config_verify_code=""
    fi
}

get_ip_info() {
    portal=`$HTTP_REQ http://api.$1portal.swjsq.vip.xunlei.com:$2/v2/queryportal`
    portal_ip=`echo $portal|grep -oE '([0-9]{1,3}[\.]){3}[0-9]{1,3}'`
    portal_port_temp=`echo $portal|grep -oE "port...[0-9]{1,5}"`
    portal_port=`echo $portal_port_temp|grep -oE '[0-9]{1,5}'`
}

#获取加速API
get_kuainiao_api() {
    get_ip_info "" "81"
    portal_dn_ip=$portal_ip
    if [ -z "$portal_dn_ip" ]; then
        dbus set kuainiao_run_warnning_dn="迅雷快鸟服务下行API获取失败，请检查网络环境，或稍后再试!"
    else
        api_url="http://$portal_dn_ip:$portal_port/v2"
        dbus set kuainiao_api_dn=$api_url
    fi

    get_ip_info "up" "80"
    portal_up_ip=$portal_ip
    if [ -z "$portal_up_ip" ]; then
        dbus set kuainiao_run_warnning_up="迅雷快鸟服务上行API获取失败，请检查网络环境，或稍后再试!"
    else
        api_up_url="http://$portal_up_ip:$portal_port/v2"
        dbus set kuainiao_api_up=$api_up_url
    fi

    if [ -z "$portal_dn_ip" ] && [ -z "$portal_up_ip" ]; then
        dbus set kuainiao_run_warnning="迅雷快鸟服务[下行,上行]API获取失败，请检查网络环境，或稍后再试!"
    fi
}

#检测提速带宽
bandwidth(){
    _ts=`date +%s`000
    resp=`$HTTP_REQ "$1/bandwidth?peerid=$peerid&client_type=android-$2-$app_version&client_version=android$2-$app_version&os=android-8.1.0.27Google&time_and=$_ts&userid=$uid"`
    echo $resp
}

kn_upgrade(){
    _ts=`date +%s`000
    resp=`$HTTP_REQ "$1/upgrade?peerid=$peerid&client_type=android-$2-$app_version&client_version=android$2-$app_version&os=android-8.1.0.27Google&time_and=$_ts&userid=$uid&sessionid=$session&user_type=1&dial_account=$dial_account"`
    echo $resp
}

#检测快鸟加速信息
get_bandwidth(){
    if [[ -n "$api_url"  || -n "$api_up_url" ]]; then
        band=$(bandwidth $api_url "swjsq")
        can_dn_upgrade=`echo $band|awk -F '"can_upgrade":' '{print $2}'|awk -F ',' '{print $1}'`
        dial_account=`echo $band|awk -F '"dial_account":' '{print $2}'|awk -F '"' '{print $2}'`
        dbus set kuainiao_can_upgrade_dn=$can_dn_upgrade
        dbus set kuainiao_dial_account=$dial_account

        #判断是否满足加速条件
        if [ "$can_dn_upgrade" == "1" ]; then
            #获取下行加速详细信息
            old_downstream=`echo $band|awk -F '"bandwidth":' '{print $2}'|awk -F '"downstream":' '{print $2}'|awk -F ',' '{print $1}'`
            max_downstream=`echo $band|awk -F '"max_bandwidth":' '{print $2}'|awk -F '"downstream":' '{print $2}'|awk -F ',' '{print $1}'`

            upgrade=$(kn_upgrade $api_url "swjsq")
            errcode=`echo $upgrade|awk -F '"errno":' '{print $2}'|awk -F ',' '{print $1}'`
            dbus set kuainiao_can_upgrade_dn_errcode=$errcode

            if [ "$errcode" == "0" ] || [ "$errcode" == "812" ]; then
                dbus remove kuainiao_run_warnning_dn
            elif [ "$errcode" == "518" ]; then
                can_dn_upgrade="518"
                dbus set kuainiao_can_upgrade_dn="518"
                dbus set kuainiao_run_warnning_dn="抱歉！当前账号非下行提速会员，请开通后再试！"
            else
                can_dn_upgrade="-1"
                dbus set kuainiao_can_upgrade_dn="-1"
                dbus set kuainiao_run_warnning_dn=`echo $upgrade|awk -F '"richmessage":' '{print $2}'|awk -F '"' '{print $2}'`
            fi
        else
            if [ -z "$dial_account" ]; then
                errcode==`echo $band|awk -F '"errno":' '{print $2}'|awk -F ',' '{print $1}'`
                if [ "$errcode" == "3103"]; then
                    dbus set kuainiao_run_warnning_dn="下行已达上限，无需加速！"
                else
                    message==`echo $band|awk -F '"message":' '{print $2}'|awk -F ',' '{print $1}'`
                    dbus set kuainiao_run_warnning_dn=$message
                fi
            else
                dbus set kuainiao_run_warnning_dn="该账号不支持下行加速"
            fi
        fi

        # 上行加速
        band=$(bandwidth $api_up_url "uplink")
        can_up_upgrade=`echo $band|awk -F '"can_upgrade":' '{print $2}'|awk -F ',' '{print $1}'`
        dbus set kuainiao_can_upgrade_up=$can_up_upgrade
        if [ -z "$dial_account" ]; then
            dial_account=`echo $band|awk -F '"dial_account":' '{print $2}'|awk -F '"' '{print $2}'`
            dbus set kuainiao_dial_account=$dial_account
        fi

        if [ "$can_up_upgrade" == "1" ]; then
            old_upstream=`echo $band|awk -F '"bandwidth":' '{print $2}'|awk -F '"upstream":' '{print $2}'|awk -F '}' '{print $1}'`
            max_upstream=`echo $band|awk -F '"max_bandwidth":' '{print $2}'|awk -F '"upstream":' '{print $2}'|awk -F '}' '{print $1}'`

            upgrade=$(kn_upgrade $api_up_url "uplink")
            errcode=`echo $upgrade|awk -F '"errno":' '{print $2}'|awk -F ',' '{print $1}'`
            dbus set kuainiao_can_upgrade_up_errcode=$errcode
            

            if [ "$errcode" == "0" ] || [ "$errcode" == "812" ]; then
                dbus remove kuainiao_run_warnning_up
            elif [ "$errcode" == "518" ]; then
                can_up_upgrade="518"
                dbus set kuainiao_can_upgrade_up="518"
                dbus set kuainiao_run_warnning_up="抱歉！当前账号非上行提速会员，请开通后再试！"
            else
                can_up_upgrade="-1"
                dbus set kuainiao_can_upgrade_up="-1"
                dbus set kuainiao_run_warnning_up=`echo $upgrade|awk -F '"richmessage":' '{print $2}'|awk -F '"' '{print $2}'`
            fi
        else
            if [ -z "$dial_account" ]; then
                errcode==`echo $band|awk -F '"errno":' '{print $2}'|awk -F ',' '{print $1}'`
                if [ "$errcode" == "3103"]; then
                    dbus set kuainiao_run_warnning_up="上行已达上限，无需加速！"
                else
                    message==`echo $band|awk -F '"message":' '{print $2}'|awk -F ',' '{print $1}'`
                    dbus set kuainiao_run_warnning_up=$message
                fi
            else
                dbus set kuainiao_run_warnning_up="该账号不支持上行加速"
            fi
        fi

        if [ "$can_dn_upgrade" != "1" ] && [ "$can_up_upgrade" != "1" ]; then
            dbus set kuainiao_run_warnning="T_T 不能加速啊，不满足加速条件哦~~"
        fi
    fi
}

#快鸟加速注销
kuainiao_recover(){
    _ts=`date +%s`000
    $HTTP_REQ "$api_url/recover?peerid=$peerid&client_type=android-swjsq-$app_version&client_version=androidswjsq-$app_version&os=android-8.1.0.27Google&time_and=$_ts&userid=$uid&user_type=1&dial_account=$dial_account"
    $HTTP_REQ "$api_up_url/recover?peerid=$peerid&client_type=android-uplink-$app_version&client_version=androiduplink-$app_version&os=android-8.1.0.27Google&time_and=$_ts&userid=$uid&user_type=1&dial_account=$dial_account"
}

#将执行脚本写入crontab定时运行
add_kuainiao_cru(){
    if [[ "$can_dn_upgrade" == "1" || "$can_up_upgrade" == "1" ]] && [ -f /koolshare/kuainiao/kuainiao.sh ]; then
        #确保有执行权限
        chmod +x /koolshare/kuainiao/kuainiao.sh
        cru a kuainiao "*/10 * * * * /koolshare/kuainiao/kuainiao.sh"
    fi
}

#加入开机自动运行
auto_start(){
    if [[ "$can_dn_upgrade" == "1" || "$can_up_upgrade" == "1" ]] && [ "$kuainiao_start" == "1" ] && [ -f /koolshare/kuainiao/kuainiao.sh ]; then
        if [ -f /koolshare/init.d/S80Kuainiao.sh ]; then
            rm -rf /koolshare/init.d/S80Kuainiao.sh
        fi
        cat > /koolshare/init.d/S80Kuainiao.sh <<EOF
#!/bin/sh
cru a kuainiao "*/10 * * * * /koolshare/kuainiao/kuainiao.sh"
dbus ram kuainiao_run_i=6
sh /koolshare/kuainiao/kuainiao.sh
EOF
        chmod +x /koolshare/init.d/S80Kuainiao.sh
    fi
}

#停止快鸟服务
stop_kuainiao(){
    kuainiao_recover
    #停掉cru里的任务
    if [ ! -z "$kuainiaocru" ]; then
        cru d kuainiao
    fi
    #停止自启动
    if [ -f /koolshare/init.d/S80Kuainiao.sh ]; then
        rm -rf /koolshare/init.d/S80Kuainiao.sh
    fi
    #清理运行环境临时变量
    dbus remove kuainiao_run_i
    dbus remove kuainiao_run_orig_day
    dbus remove kuainiao_config_session
    dbus remove kuainiao_run_warnning
    dbus remove kuainiao_run_warnning_dn
    dbus remove kuainiao_run_warnning_up
    dbus remove kuainiao_api_dn
    dbus remove kuainiao_api_up
    dbus remove kuainiao_config_uid
    dbus remove kuainiao_dial_account
    dbus remove kuainiao_can_upgrade_dn
    dbus remove kuainiao_can_upgrade_up
    dbus remove kuainiao_can_upgrade_dn_errcode
    dbus remove kuainiao_can_upgrade_up_errcode
    dbus remove kuainiao_can_keepalive_dn_errcode
    dbus remove kuainiao_can_keepalive_up_errcode
    dbus ram kuainiao_run_status=0
}

##主逻辑
#执行初始化
stop_kuainiao

if [ "$kuainiao_enable" == "1" ]; then
    #登陆迅雷获取uid
    get_xunlei_uid
    #判断是否登陆成功
    if [ -n "$uid" ]; then
        get_kuainiao_api
        if [ ! -z "$portal_dn_ip" ] || [ ! -z "$portal_up_ip" ]; then
            get_bandwidth
            if [[ "$can_dn_upgrade" == "1" || "$can_up_upgrade" == "1" ]]; then
                dbus set kuainiao_config_downstream=$(expr $old_downstream / 1024)
                dbus set kuainiao_config_downstream_max=$(expr $max_downstream / 1024)
                dbus set kuainiao_config_upstream=$(expr $old_upstream / 1024)
                dbus set kuainiao_config_upstream_max=$(expr $max_upstream / 1024)
                #写入crontab
                add_kuainiao_cru
                #开机执行
                auto_start
                #开始初始化执行
                sleep $kuainiao_time
                #判断cru脚本是否正在执行
                kuainiao_is_run=$(ps|grep '/koolshare/kuainiao/kuainiao.sh'|grep -v grep)
                if [ ! -z "$kuainiao_is_run" ]; then
                    sleep 5
                fi
                dbus ram kuainiao_run_i=0
                sh /koolshare/kuainiao/kuainiao.sh
            fi
        fi
    fi
else
    dbus remove kuainiao_device_sign
    dbus remove kuainiao_config_verify_url
    dbus remove kuainiao_config_verify_code
    dbus remove kuainiao_config_verify_key
    dbus remove kuainiao_config_peerid
fi
